# Changelog

## [Oct 19th 2024] Bugfix Update

- Minor bugfixes

## [Oct 12th - Oct 19th 2024] Update: Building and Farming Update

- Start working on a new entity API to replace mobs_redo
- Added many new foods
    - Added Carrots
    - Added Bananas
    - Added Potatoes, Cooked Potatoes, and Sliced Potatoes
    - Added French Fries which can be made from frying Sliced Potatoes
- Added Farming Mechanics
    - Added Hoes
    - Added Wheat Crops
    - Added Carrot Crops
    - Added Potato Crops
- Added Frying Pans with a new cooking system
- Added Stained Glass
- Added Stone/Darkstone/Granite/Andesite Bricks
- Glass should be connected with connected glass setting now
- Added the first settings to the game including:
    - always_day (Always Day)
    - fire_spreads (Fire Spreads)
    - acid_spreads (Contagious Acid Spreads)
- You can no longer jump over fence
- Added Concrete which is really just a blank colored block :|
- Added Tuff and Diorite both of which can spawn in caves
- Added Diorite and Tuff Bricks
- Added Ferns
- Added Enchanted Pickaxe, somehow forgot to add it several updates ago.
- Axes can be used as weapons now

## [Oct 6th - Oct 12th 2024] Update: Texture Update

This update contains breaking changes due to the grass revamp

- Change the games style in terms of textures
- Creative block breaking speed increased
- "Revamped" grass
- Added Bedrock as a barrier between worlds
- Removed enchanted obsidian, more ways to obtain magic shards will be added in the future

## [Oct 6th 2024] Unnamed Minor Update

- Make monsters spawn less
- Update every node still using the old block group

## [Oct 5th 2024] Unnamed Minor Update

- Overworld bottom goes from -200 to -65
- Monsters should spawn much more
- Change pickaxe digging speeds

## [Sep 29th - Oct 5th 2024] Update: World Update

This update completely breaks the API and game lol.

The entire codebase was also refactored, which ended up breaking all the schematics.
So I had to go through the tedious process and fix them all.

- Added "Worlds" which are like Minecraft's own Dimensions
    - Added Ice World
    - Added Slime World
    - Added Lava World
    - Added Mushroom World
- Added Darkstone
- Added Glowslime
- Added Magma
- Give the Heater Device and Freezer Device more abilities with new `heatable` and `coolable` groups
- Added World Tokens which let you travel between worlds
- Added Fossils
- Removed Vyn Forest, Old Growth Forest and Jungle
- Zinc wires are now configurable like Minecraft's Redstone Repeater; It comes in 4 different levels:
    - 1 = 0.1 seconds
    - 2 = 0.2 seconds
    - 3 = 0.4 seconds
    - 4 = 0.8 seconds
- Replaced Purple Mushrooms with Glowshrooms
- Added Homes System
- Removed Waypoints System
- Added Flint and Flint and Steel

## [Sep 29th 2024] Unnamed Minor Update

- Replace Delayer Wire with Zinc Wire, giving Zinc a purpose
- Give explosions more particles, including sparks
- Change `default_stack_max` to 999
- TNT will no longer explode if the TNT block has been removed
- Fixed lily pads appearance
- Windballs launch you forward a bit less now
- Replace `electricity` group with `electric`

## [Sep 27th - Sep 28th 2024] Update: The Electricity Update

- Add a new electricity system to replace the old discontinued one
- Added "devices":
    - Freezer Device (Freezes nodes with freezable group)
    - Heater Device (Thaws nodes with thawable group (Converts to water by default, __thaw_node in the node definition can change this))
- Added wires:
    - Copper Wire
    - Delayer Wire (Like Copper Wire but waits 0.2 seconds before sending a pulse, meaning 5 delayers = 1 second)
- Humans now have a chance to drop 1 to 4 apples.

## [Sep 3rd - Sep 4th 2024] Unnamed Minor Update

- Vyn forest is now a snowy forest like biome
- Decorations no longer spawn in flat worlds
- Added biome "flat" which is only available in flat worlds
- Nodes like torches are now floodable
- Windballs now launch you in the direction you're moving at the cost of reduced launch height
- Started a wiki for players

## [Aug 23rd 2024] Unnamed Minor Update

- Added Vyn Forest (WIP)

## [Aug 8th 2024] Unnamed Minor Update

- New dandelion texture
- New crate and mimic texture
- Emeralds are now level 3 instead of 4
- Added raw tin and zinc

## [Aug 4th - Aug 7th 2024] Update: Balancing Update

- Try to balance the game
- Added axes
- Removed obsidian mounds
- Make snowman towers more rare
- Removed saplings
- Use `cracky`, `choppy`, etc. groups instead of `block`
- Lootboxes now have to be dug instead of right-clicked.
- Drowning deals more damage
- Explosions deal more damage
- Revamped ore API
- Removed the following ores: Rubies, Quartz, and Lapis Lazuli

## [Aug 3rd 2024] Unnamed Minor Update

- Adjust biomes a bit
- New ice spike structure

## [Aug 3rd 2024] Unnamed Update

- Added new node/block types
  - Added purple mushroom
  - Added vyn wood
- Debuff some lootboxes
- Add more loot to the "Trash" lootbox
- Add PyuTestCore.registered_*
- Saplings now take a random value between 18 and 35 seconds to grow instead of 6 seconds
- Updated saplings to new schematic names
- Black roses no longer spawn normally
- The `/replacenear` command now interprets anynode as anyblock
- New torch texture
- Indent code

## [Jul 26th 2024] Unnamed Minor Update

- Vines are now flammable
- Players now deal 10000 damage in creative mode
- Added water bottles

## [Jul 26th 2024] Unnamed Minor Update

- Add large jungle trees
- CamelCase all schematics
- Rename tree* schematics to proper tree names

## [Jul 26th 2024] Unnamed Minor Update

- Grasslands now act as a "middle point" for all biomes
- Trees now spawn in grasslands

## [Jul 24th - Jul 25th 2024] Update: The "Yet Another Unnamed Update" Update

- Added lapis lazuli
- Added lime colored blocks
- Added bones and bone blocks
- Humans and monsters now drop bones
- Added crafting recipes for bosses
- Added structures where bosses spawn
- Buff the necromancer
- Added large mushroom forests
- Change climate of mushroom fields
- Added `/rtp` command to teleport to random locations
- Ice is slightly more slippery
- Wood can now be rotated on all axis
- Fix ladders appearing as vines in the inventory
- Added small mushrooms
- Lava now spawns in caves
- Removed obsolete decorations
- Added new mushroom types

## [Jul 18th - Jul 24th 2024] Update: The Unnamed Update

This update contains breaking changes!

- Revamped wood
- Removed huts
- Added crystal lanterns
- New monster and player/human textures
- Added some biomes inspired by the Minecraft mod [Biomes O' Plenty](https://www.curseforge.com/minecraft/mc-mods/biomes-o-plenty)
    - Added Aspen Forest
    - Added Redwood Forests
- Added stone and wooden swords
- Revamp source tree
- Add structure API
- New snow texture
- Add snowman boss battle :0
- Make magic shards more common
- Change humidity and heat of each biome
- Removed wastelands
- Added wind warrior boss battle
- Added windballs
- Added ocean ruins
- Added necromancer boss battle
- Remove light's ability to change the time
- PyuTest now has an offical name: Nodelands!
- Added stone bricks

## [Jul 17th 2024] Unnamed Minor Update

- Added sugar crafting recipe
- Added very tall birch tree (tree10)
- Added old growth birch forest

## [Jul 13th 2024] Unnamed Minor Update

- Add crafting recipe for slime
- Decrement hotbar slot count from 9 to 8

## [Jul 13th 2024] Update: Slimy Swamps

- Added swamps
- Added vines
- Lily pads now spawn naturally in swamps
- Sugarcanes naturally spawn in deserts, swamps, and savannas

## [Jul 13th 2024] Unnamed Minor Update

- Added black roses.
- Added `_pyutest_biome_flowering_extra` biome type, where flowers spawn a lot more.
- Give cherry groves and meadows the `_pyutest_biome_flowering_extra` biome type.

## [Jul 12th 2024] Update: Floral Update

- Add a bunch of flora to finish dyes
- Added `colored` group
- Black blocks no longer give players heart attacks (They were just too dark.)
- Rename grassy hills to meadow
- Flowers now spawn in meadows
- New cherry tree model

## [Jul 11th - Jul 12th 2024] Update: Smithing Update

- Updated Unified Inventory and Mobs Redo
- Added furnaces
- Implement the workbench from the "Adventure and Magic Update"
- Added bricks (Not the block, but the item)
- Clay now spawns in the world
- Fire now spreads instead of just sitting there and damaging entities.
- Add terracotta that I forgot to add in the "Adventure and Magic Update"

## [Jul 10th 2024] Minor Update: Fence Update

- Added fences
- Humans no longer spawn below sea-level
- Fix birch forests being too small

## [Jul 10th 2024] Update: Cave Update

- Added andesite and granite
- Added various gemstones and metals
    - Added Tin
    - Added Zinc
    - Added Amethyst Quartz
    - Added Pink Quartz
    - Added Rubies
- Granite and andesite will spawn underground as large blobs
- Added different types of ore clusters
- Change classification of a "major" update

## [Jul 10th 2024] Unnamed Minor Update

- Add Unified Inventory categories
- Fixed ocean biomes messing up caves

## [Jul 9th 2024] Unnamed Minor Update

- Increase Torch light range from 12 to minetest.LIGHT_MAX (14)

## [Jul 9th 2024] Hotfix: 07.09.2024

- Fix ores not spawning in any Y level below PyuTestCore_DeepOceanMin (-31)
- Saplings now spawn trees for all new different tree types

## [Jul 7th - Jul 8th 2024] Major Update: World and Building Update

This update aims to update the world generation and add new building blocks!

- Added new grass variants
    - Added dark grass
    - Added swampy grass
    - Added savanna grass
- Forests now use dark grass instead of normal grass
- Updated various other biomes
- Added logs
    - Added oak logs
    - Added savanna logs
- Updated leaves texture
- Added snowy leaves
- Added cherry leaves
- Revamped trees
- Removed snowy camp structure
- Removed oillands biome
- Added new tree types
    - Added giant tree
    - Added snowy tree
    - Added birch trees
    - Added giant birch trees
    - Added cherry trees
- Added various biomes
    - Grassy Hills
    - Old Growth Forest
    - Snowy Forest
    - Savannas
    - Taigas
    - Birch Forest
    - Cherry Grove
- Added ocean biomes
    - "Normal" Ocean
- Added beaches and snowy beaches

## [Jun 26th - Jul 6th 2024] Major Update: Adventure and Magic Update

**This update contains breaking changes!!**

- Adjusted Sprinting Speed
- Diamonds, Emeralds, and Gold are now much rarer
- Update Copper Color
- Added Weathering to Copper Ore
- Added Stone Pickaxe
- Added Magic Shards
- Replaced Crying Obsidian with Enchanted Obsidian (hehe microsoft cant sue me now)
- Added Structure Obsidian Mound where Enchanted Obsidian May Spawn.
- Magic Shards can Drop from Enchanted Obsidian Blocks
- Added Enchanted Tools
    - Added Enchanted Sword
    - Added Enchanted Pickaxe
- Removed a Bunch of Colored Blocks (Because I don't want to add that much dyes, flowers, and crafting recipes)
- Added String and Dyes
- Replaced Every Colored Block with \<COLOR\> Wool Block
- Added Recipe for Red, Blue, Yellow, and Purple Dye
- Bring Back Old Dirt Functionality
- Remove Coarse Dirt
- Major Codebase Refactors
- Added Sugarcanes
- Added Eggs and Spawn Eggs
- Fire and Lava Now Creates Light
- Added Strings to Resource Lootboxes
- Removed Liquid Lootbox
- Added Block Digging Sound
- Added Monsters and Humans
- Added Mimics
- Remove Aliases
- "Decentralize" PyuTest APIs
    - This means that PyuTest APIs no longer assume blocks, entities, bla bla bla are being defined for the pyutest_core mod
- Remove Colors from Lootboxes
- Unlimited Blocks in Creative Mode
- Fast Breaking Speeds in Creative Mode
- Added Clay along with Terracotta
- Added More Decorative Blocks
    - Added Bricks
- Added `acid_vulnerable` Group Blocks without this Group will no Longer be Destroyed by Contagious Acid
- Revamped Sponge
- Discontinue Electricity :(
- Rename Hellbound biome to Volcano Biome
- Replace Hellstone with Molten Rock
- Fire Now Spawns in the Volcano Biome
- New Player Texture
- New Lava and Fire Textures
- Flowing Liquids Have "Shape" Now
- Added Slime Blocks
- Ice is Now Slippery
- Torchs Now Rotate Based on How You Place Them
- *Finally* Added Stairs
- Added Furniture
    - Added Tables
    - Added Chairs
    - Added Mini Tables
- Minor Texture Changes
- Added Gravel
- Added Fireflies
- Added `explode` command
- Added `place` command
- Added a Bunch of Tiny Enhancements
- Added Crate Opening Sound

Now that I think of it, this wasn't much of an "adventure" update..

... next update will have more adventure!

## [Some Day I Don't Remember] Unnamed Minor Update

- Added Ice Spikes Biome
- Removed Mushrooms from Forests
- Adjusted Sprinting Speed
- Bring back Unified Inventory
- Adjusted Biome Tempatures

## [Jun 17th - 18th 2024] Update: Electricity Update Pt.1 (Discontinued)

- Added Copper
- Added Copper Wires
- Added Electrical Devices
    - Added Time Device
    - Added Block Setter Device
- Minor Texture Adjustments
- Acid Now Damages Players

## [Jun 15th - 16th 2024] Major Update: Survival Update Pt. 3

**This update contains breaking changes!!**

- Game Exists Alpha and Enters Beta

- Added Diamonds and Emeralds
- Added Block Variants of Ores
- Added Wheat
- Added Texture to Haybales
- Haybales Now Spawn Naturally in Grasslands
- Added Bread
- Added Waypoints Useable via the `/waypoint` and `/teleportwaypoint` Commands
- Replace Pickaxe with Wooden Pickaxe
- Nerf Hand and Nerf Wooden Pickaxe Breaking Speeds
- Add Iron Pickaxe and Diamond Pickaxe
- Added Iron and Diamond Sword
- Added Dummy Entity
- Added Spellbooks
    - Added Fire Spellbook
    - Added Explosion Spellbook
- Removed Coins from Resource Lootbox
- Updated Sponge Texture
- Explosions Now Damage Players
- Fire Now Damages Players
- Lava Now Damages Players
- Implement Crates
- Added Crafting Recipe to Crates
- Changed "Useless" Lootbox Type Color Tint to Purple to Tell the Difference Between Crates
- Dirt Will Now Turn Into Grass if No Block is Above it
- Added Coarse Dirt as a Replacement for the Old Dirt

## [Jun 15th 2024] Minor Update: Minor Texture Change

- Updated the Apple Texture

## [Jun 15th 2024] Minor Update: Minor Lootbox Change

- Resource Lootbox Now Gives Player 5 Apples

## [Jun 15th 2024] Minor Update: Add Aliases for Building Blocks

- Added Aliases in the Format BLOCK_TYPE ex. dirt_slab

## [Jun 15th 2024] Update: Survival Update Pt. 2

- Added Mining Mechanics
    - Added Coal Lump and Ore
    - Added Iron Ingot and Ore
    - Added Gold Ingot and Ore
- Added Apples
- Lootboxes Now Spawn in Every Biome
- Coins Can Now Be Crafted
- Iron Blocks Can Now Be Crafted
- Torches Can Now Be Crafted
- Updated Contagious Acid Recipe

## [Jun 14th 2024] Minor Update: Switch to sfinv

- Replaced unified_inventory with sfinv
- Added cg_plus (Crafting Guide Plus)

## [Jun 14th 2024] Update: Luck and Boxes

- Added Lootboxes
    - Added Trash Lootbox
    - Added Resource Lootbox
    - Added Griefer's Dream Lootbox
    - Added Liquid Sources Lootbox
    - Added Lighting Lootbox
- Lootboxes spawn across various biomes
- Revamped Bomb

## [Jun 14th 2024] Update: Items and Utilites Update

- Added Gunpowder, Coins, Sugar, and Ash
- Added `replacenear` command for editing your worlds
- New Flower Type
- TNT Crafting Recipe
- Added Crying Obsidian
- New Grass Type
- Added New Colored Blocks
- Revamp Light Texture

## [Jun 12th 2024] Update: Survival Update Pt. 1

- Added Survival Mechanics
- Added Crafting Recipes
- Light Block Can Now Control Time
- Tweaks to the Pickaxe and Contagious Acid
- New Pickaxe Texture

## [Jun 11th 2024] Unnamed Update

- Update Contagious Acid
- Added Haybale Placeholder
- Added Pink and "Cherry" Colored Blocks
- Added Deadbushes, Barriers, Fire, and TNT
- Added Oil, and Liquid Acid
- Added New Biomes: Oillands

## [Jun 10 2024] Unnamed Update

- Added New Biomes
- Added Contagious Acid
- Added Blue Daisies
- Major Code Refactor
- Added Trees and Mushrooms
- Added New Blocks

## [Jun 8 2024] Unnamed Minor Update

- Added Dandelions

## [Jun 8 2024] Unnamed Update

- Added Biomes and Structures.
- Added Snow, Sand, Sandstone and Ice.
- New Grass Texture
- Add Placeholder for Trapdoors

## [Jun 8 2024] Unnamed Update

- Added Logo
- Added Colored Blocks
- Update Sticks

## [Jun 7-8 2024] Initial Creation

- Added Grass, Dirt, Stone, Light, Torch, Sponge, Glass, Flower (Now called Rose), Iron
- Added Block Sounds
- Added Water
- Added Sticks and Pickaxe
